/*  Example implementation of a selection sort
    Copyright (C) 2002  Clinton Ebadi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "algorithm.h"

/* smallest returns the index of the smallest value from low..high */
static int smallest (void* data[], cmp_func cmp, unsigned int low, 
		       unsigned int high);

void
selection_sort (void* data[], cmp_func cmp, unsigned int sz)
{
  int i;
  int small;

  for (i=0;i<sz;++i)
    {
      small = smallest (data, cmp, i, sz-1);
      cke_swap (void*, data[i], data[small]);
    }

  return;
}

int
smallest (void* data[], cmp_func cmp, unsigned int low, unsigned int high)
{
  int i;
  int small = low;

  for (i=low+1;i<=high;i++)
    {
      if (cmp (data[small], data[i]) == 1)
	small = i;
    }

  return small;
}
