/*  Simple Linked List Library
    Copyright (C) 2002  Clinton Ebadi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef CKE_PROJ_CLIST_H
#define CKE_PROJ_CLIST_H

struct _link
{
  struct _link* next;
  struct _link* prev;
};

typedef struct _link link;

struct _list
{
  link* head;
  link* tail; /* make appending constant instead of linear */
};

typedef struct _list list;

list* make_list (); /* returns a new list */

list* list_destroy (); /* destroys a list */

#endif /* CKE_PROJ_CLIST_H */
