/*  Pair Data Structure Example
    Copyright (C) 2001  Clinton Ebadi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#if HAVE_MALLOC_H
# include <malloc.h>
#else
# include <stdlib.h>
#endif

#include "pair.h"

pair*
make_pair (void* first, void* second) {

  pair* temp = malloc (sizeof (pair));
  if (temp == NULL)
    return NULL; /* oops! didn't allocate */

  temp->first = first;
  temp->second = second;

  return temp;

}

void*
pair_get_first (pair* data) {

  if (data == NULL)
    return NULL; /* evil user trying to fool me */

  return data->first;

}

void*
pair_get_second (pair* data) {

  if (data == NULL)
    return NULL;

  return data->second;

}

void pair_set_first (pair* p, void* data) {

  if (p == NULL)
    return;

  p->first = data;

}

void pair_set_second (pair* p, void* data) {

  if (p == NULL)
    return;

  p->second = data;

}
