/*  Queue Data Structure Example
    Copyright (C) 2001  Clinton Ebadi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef CKE_PROJ_QUEUE_H
#define CKE_PROJ_QUEUE_H

#include <stdlib.h> /* malloc and friends */

struct _queue
{
  void** data;
  size_t size;
  int back;
  int front;
};

typedef struct _queue queue;

queue* make_queue (size_t); /* make a new queue with this default size */

void* queue_peak (queue*); /* peaks at top of queue */

void queue_pop (queue*); /* pops top of queue off */

void queue_push (queue*,void*); /* pushes element onto queue */

void queue_destroy (queue*); /* destroys queue */


#endif /* CKE_PROJ_QUEUE_H */
