;    Binary Search Algorithm Example
;    Copyright (C) 2002  Clinton Ebadi
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;; binary-search vec: vector to search in, item: item to be found,
;; cmp: comparison function 
;; returns #t if found, #f if not found

(define binary-search
  (lambda (vec cmp item)
    (let ((first 0)
	  (last (- (vector-length vec) 1))
	  (found #f))
      ;; named-let inside of let needed because middle uses first and last
      (let loop ((first first)
		 (middle (/ (+ first last) 2))
		 (last last))
	(let ((mid (vector-ref vec (inexact->exact middle))))
	  (cond ((= (cmp item mid) 0)
		 (set! found #t))
		((< (cmp item mid) 0)
		 (set! last (- middle 1)))
		((> (cmp item mid) 0)
		 (set! first (+ middle 1))))
	  (if (not found)
	      (if (> first last)
		  #f
		  (loop first (inexact->exact (/ (+ first last) 2)) last))
	      #t ))))))