;    Insertion Sort Algorithm Example
;    Copyright (C) 2002  Clinton Ebadi
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;; insertion-sort vec: vector to search in, cmp: comparison function 
;; modifies vec in place

(load (cke-lib-dir "vswap.scm")) ; loads vswap

(define insertion-sort
  (lambda (vec cmp)
    (if (not (vector? vec))
	(throw 'type-error))
    (let ((size-of-vec (- (vector-length vec) 1)))
      (do ((i 0 (+ i 1)))
	  ((> i size-of-vec))
	(do ((j i (- j 1))
	     (brk #f))
	    ((and (<= j 0) (not brk)))
	  (if (< (cmp (vector-ref vec j) (vector-ref vec (- j 1))) 0)
	      (vswap vec j (- j 1))
	      (set! brk #t)) ; break out of loop
	)))))