;    Linear Search Algorithm Example
;    Copyright (C) 2002  Clinton Ebadi
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;; linear-search vec: vector to search in, item: item to be found,
;; cmp: comparison function 
;; returns #t if found, #f if not found

(define linear-search
  (lambda (vec cmp item)
    (let loop ((loc 0))
      (cond 
       ((= (cmp item (vector-ref vec loc)) 0) #t)
       ((>= (+ loc 1) (vector-length vec)) #f)
       (else (loop (+ loc 1)))))))
