; -*- scheme -*-
; guile init for unknown_lamer

; make guile use GNU readline for better interactive mode
(use-modules (ice-9 readline))
(activate-readline)

;; my custom functions

; returns my lib dir
; takes 1 optional arg, file that will be appended to dir
; dir includes the last slash
; assumes $HOME is in the environment, which is always true
; on POSIX systems
(define cke-lib-dir 
  (lambda arg
    (let ((homedir (getenv "HOME")))
    (define cke_lib_dir (string-append homedir "/.cke_guile/"))
    (if (not (null? arg)) 
	(string-append  cke_lib_dir (car arg))
	"/home/clinton/.cke_guile"
	)
    )))


;; my custom macros
; report: to make Oleg's code work
(define-macro report: 
  (let ((temp (gensym))) 
    (lambda (temp) `(display ,temp))))

; bye (its more fun than quit!
(define-macro bye
  (lambda () (quit )))

;; load libs I use often
(load (cke-lib-dir "defstruct.scm"))